;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	NeoGeo WW2 by Charles Doty (cdoty@netzero.net)
;	Game.asm - Contains the game specific code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	jsr		Setup
	jsr		SetupTilemap

	move.w	#$0000, ScrollPos	; Set scroll position to 0

	move.l	#$0400, a0			; Setup VRAM address
	lea		TilesMap, a1		; Set source tilemap address
	move.w	#MAPWIDTH, d0		; and MAPWIDTH collumns
	move.w	#15, d1  			; Do 16 lines
	jsr		FillTilemap

	move.b	#0, VertBlank		; Reset Vertical Blank

	move.w	#$2000, sr			; Enable interrupts

Loop:
	cmp.b	#1, VertBlank		; Wait sync
	bne		Loop

	jsr		HandleInput

	bra		Loop

; Initialize
Setup:
	move.w	#0, $3C0006			; ???
	move.w	#7, $3C000C			; IRQ 7 acknoledge????

	lea		$400000, a0			; A0 = ptr to NeoGeo palette
	lea		Palettes, a1		; A1 = ptr to our palette
	move.w	#EndPalettes-Palettes, d0	; D0 = palette size
	jsr		SetupPalette

	jsr		$C004C2				; Call bios routine
	jsr		$c004C8 			; Call bios routine
	jsr		$c0044A 			; Call bios routine

	rts

HandleInput:
	jsr		ReadController

	move.b	d0, d1

	and.b	#1, d1
	beq		InputDown

	move.w	ScrollPos, d0

	cmp.w	#0, d0
	beq.s	EndInput

	sub.w	#$1, d0
	move.w	d0, ScrollPos

	bra.s	EndInput

InputDown:
	move.b	d0, d1

	and.b	#2, d1
	beq		NoInput

	move.w	ScrollPos, d0

	cmp.w	#$0680, d0
	beq.s	EndInput

	add.w	#$1, d0
	move.w	d0, ScrollPos

EndInput:
	move.l	#$0400, a0			; Setup VRAM address
	lea		TilesMap, a1		; Set source tilemap address
	move.w	#MAPWIDTH, d0		; and MAPWIDTH collumns
	move.w	#15, d1  			; Do 16 lines
	jsr		FillTilemap

NoInput:
	rts

	ALIGN	4
Palettes:
	INCBIN	"tiles.pal"
	INCBIN	"font.pal"
EndPalettes:

	ALIGN	4
TilesMap:
	INCBIN	"level1.mp1"
TilesMapEnd:

