;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	NeoGeo WW2 by Charles Doty (cdoty@netzero.net)
;;;;	NeoGeo.asm - Contains the initialization code needed for the NeoGeo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	INCLUDE "Includes\Defines.inc"

	org		$0000

	dc.l	$0010F300,$00C00402,$00C00408,$00C0040E	; Stack Ptr = 0x0010F300
													; InitialPC = 0x00C00402
	dc.l	$00C00414,$00C0041A,$00C0041A,$00C0041A	; Ptr to debugging switch = 0x00C00414
	dc.l	$00C0041A,$00C00420,$00C00426,$00C00426
	dc.l	$00C00426,$00C00426,$00C00426,$00C0042C
	dc.l	$00C00426,$00C00426,$00C00426,$00C00426
	dc.l	$00C00426,$00C00426,$00C00426,$00C00426
	dc.l	$00C00432,   VBlank,     Irq2,$00000000	; Vertical blank ptr=VBlank
    						 						; IRQ2 ptr=Irq2(see below)
	dc.l	$00000000,$00000000,$00000000,$00000000
	dc.l	$FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
	dc.l	$FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
	dc.l	$FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
	dc.l	$FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
	dc.l	$FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
	dc.l	$FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
	dc.l	$FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
	dc.l	$FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF

	dc.b	"NEO-GEO", $00							; Magic bytes
	dc.w	$0202									; 0x0202 = NGH number
	dc.l	$00000000							    ; Unknown
	dc.l	$010E000								; Pointer to debugging switch
	dc.w	$0000									; Blank
	dc.w	$0100									; Starting sprite number = 0x0100

	dc.l	JapaneseConfig							; Pointer to Japanese config
	dc.l	EnglishConfig							; Pointer to English config
	dc.l	SpanishConfig							; Pointer to Spanish config

	jmp		Start									; Entry point of program
	jmp		Start2
	jmp		Start3

JapaneseConfig:
	dc.b	"NEOGEO DEMO JP  "
	dc.l	$FFFFFFFF
	dc.w	$0364
	dc.b	$14, $13, $24, $01

EnglishConfig:
	dc.b	"NEOGEO DEMO EN  "
	dc.l	$FFFFFFFF
	dc.w	$0364
	dc.b	$14, $13, $24, $01

SpanishConfig:
	dc.b	"NEOGEO DEMO SP  "
	dc.l	$FFFFFFFF
	dc.w	$0364
	dc.b	$14, $13, $24, $01

	dc.l	Security								; Pointer to security code

Security:
	dc.l $76004A6D,$0A146600,$003C206D,$0A043E2D	; Securty code
	dc.l $0A0813C0,$00300001,$32100C01,$00FF671A
	dc.l $30280002,$B02D0ACE,$66103028,$0004B02D
	dc.l $0ACF6606,$B22D0AD0,$67085088,$51CFFFD4
	dc.l $36074E75,$206D0A04,$3E2D0A08,$3210E049
	dc.l $0C0100FF,$671A3010,$B02D0ACE,$66123028
	dc.l $0002E048,$B02D0ACF,$6606B22D,$0AD06708
	dc.l $588851CF,$FFD83607
	dc.w $4e75

; VBlank interrupt routine
VBlank:
	tst.b	$10FD80				; Bit 7 = 1 when NeoGeo logo is displayed
	bmi		DisplayedLogo

	jmp		$C00438				; Jmp in bios in NeoGeo logo display function

DisplayedLogo:
	move.w	#4, $3C000C			; IRQ 4 acknoledge?
	move.b	d0, $300001			; Watchdog

	move.b	#1, VertBlank		; Vertical Blank occured

	jsr		$C0044A

	rte

; Irq2 interrupt routine
Irq2:
	move.w	#2, $3C000C			; IRQ 2 acknoledge?
	rte

; Entry point
Start:
	lea		$10F300, sp			; Setup stack pointer
	INCLUDE	"Game.asm"

Start2:
	rts

Start3:
	rts

	ALIGN	4
	INCLUDE	"Routines.asm"

Filler:
	ds.b	$80000-Filler

	END
